# 🚀whatsmars
*`./mvnw clean package -Dmaven.test.skip`* [`java 8+`](http://www.oracle.com/technetwork/java/javase/downloads) [`mvnrepository`](http://mvn.hongxi.org)
<br>*What's Mars? Mars is the fourth planet from the Sun and the second-smallest planet in the Solar System after Mercury.*
<br>Java生态研究(**Spring Boot**🔥 + **Redis**🔥 + **Dubbo**🔥 + **RocketMQ**🔥 + **Elasticsearch**🔥)
- [Spring Boot](https://spring.io/projects/spring-boot) 解放生产力的利器
- [《Redis设计与实现》](https://e.jd.com/30189715.html) 缓存，NoSQL数据库，分布式锁，位图
- [Dubbo](http://dubbo.apache.org/en-us/) / [《企业IT架构转型之道：阿里巴巴中台战略思想与架构实战》](https://book.douban.com/subject/27039508/) 分布式RPC，微服务架构
- [《RocketMQ技术内幕：RocketMQ架构设计与实现原理》](https://e.jd.com/30446645.html) / [《Kafka权威指南》](https://e.jd.com/30442811.html) 削峰填谷，异步解耦，顺序消息，分布式事务消息，大数据分析，分布式模缓存同步
- [*Elasticsearch*](https://www.elastic.co) *搜索、分析和存储您的数据*

👻 [start.spring.io](https://start.spring.io) 👻 [wiki.hongxi.org](http://wiki.hongxi.org)

### Modules intro
Module | Intro
------ | ------
whatsmars-common | Utils公共模块
whatsmars-dubbo | 高性能分布式RPC框架
whatsmars-elasticjob | 分布式调度框架
whatsmars-elasticsearch | Elasticsearch
whatsmars-mq | 消息中间件RocketMQ,Kafka等
whatsmars-redis | Redis客户端简单封装
whatsmars-rpc | Transporter & Codec & Serialization
whatsmars-shardingsphere | 分布式数据库中间件
whatsmars-spring | Spring Framework
whatsmars-spring-boot | Spring Boot 实战
whatsmars-spring-boot-samples | Spring Boot Samples
whatsmars-spring-cloud | Spring Cloud 微服务生态
whatsmars-zk | zookeeper remoting 封装

### Rocket Stack
- [x] [*Java SE*](http://java.hongxi.org)
- [x] [*Netty*](https://github.com/netty/netty)
- [x] [*Dubbo*](https://github.com/apache/dubbo)
- [x] [*RocketMQ*](https://github.com/apache/rocketmq)
- [ ] [*Kafka*](https://github.com/apache/kafka)
- [ ] [*ZooKeeper*](https://github.com/apache/zookeeper)
- [x] [*Spring Boot*](https://github.com/spring-projects/spring-boot)
- [x] [*Spring Framework*](https://github.com/spring-projects/spring-framework)
- [x] [*Spring Data*](https://github.com/spring-projects/spring-data-examples)
- [x] [*Redis*](https://github.com/antirez/redis)
- [ ] [*Elasticsearch*](https://github.com/elastic/elasticsearch)

### Friendship links
- [*阿里巴巴Java开发手册*](https://github.com/alibaba/Alibaba-Java-Coding-Guidelines) 📚
- *技术wiki* [wiki.hongxi.org](http://wiki.hongxi.org) ✏️

### Warm tips
- Java两大核心技术：并发，NIO
- 带着问题去看源代码，没必要把源代码看完
- 看源代码最大的技巧是看英文注释，另一个技巧是日志+DEBUG
- 先看书再看源码，事半功倍，另外推荐看官方文档
- 架构师不仅要对一两个领域的技术有深入研究，还要有技术广度和判断能力

&copy; [hongxi.org](http://hongxi.org) | [wiki.hongxi.org](http://wiki.hongxi.org)
